.macos-15_options:
  resource_group: macos-15_build_server
  tags:
    - macos-m2pro-build-runner-aws

macos-15_base:
  stage: build_base
  extends:
    - .rules:merge_request_pipeline
    - .macos-15_options
  script:
    - packer init packer/templates/macos-15-base.pkr.hcl
    - packer build -var-file="packer/conf/macos-15.pkrvars.hcl" packer/templates/macos-15-base.pkr.hcl

macos-15_toolchain:
  stage: install_toolchain
  extends:
    - .rules:merge_request_pipeline
    - .macos-15_options
  needs:
    - macos-15_base
  script:
    - packer build -var-file="packer/conf/macos-15.pkrvars.hcl" packer/templates/toolchain.pkr.hcl

macos-15_test:
  stage: test
  extends:
    - .rules:merge_request_pipeline
    - .macos-15_options
  needs:
    - macos-15_toolchain
  script:
    - tart run macos-15-toolchain &
    - TART_PID=$!
    - export TARGET_HOST="$(tart ip macos-15-toolchain --wait 60)"
    - cd tests
    - bundle install
    - (TARGET_PORT=22 LOGIN_PASSWORD=gitlab bundle exec rspec spec && kill $TART_PID) || (kill $TART_PID; return 1)

xcode-16:
  stage: build_xcode
  extends:
    - .rules:merge_request_pipeline
    - .macos-15_options
  needs:
    - macos-15_test
  script:
    - packer build -var-file="packer/conf/xcode-16.pkrvars.hcl" -var-file="packer/conf/macos-15.pkrvars.hcl" packer/templates/xcode.pkr.hcl

macos-15-xcode-16-system-report:
  stage: system_report
  extends:
    - .rules:merge_request_pipeline
    - .macos-15_options
  needs:
    - xcode-16
  script:
    - packer build -var-file="packer/conf/xcode-16.pkrvars.hcl" -var-file="packer/conf/macos-15.pkrvars.hcl" packer/templates/system-report.pkr.hcl

macos-15-xcode-16-s3-upload-dev:
  stage: upload
  extends:
    - .rules:merge_request_pipeline_only
    - .macos-15_options
  needs:
    - xcode-16
  variables:
    VM_NAME: macos-15-xcode-16
    VERSION: dev-mr-${CI_MERGE_REQUEST_IID}
  script:
    - make upload-to-s3

macos-15-xcode-16-s3-upload-main:
  stage: upload
  extends:
    - .rules:default_branch
    - .macos-15_options
  needs:
    - xcode-16
  variables:
    VM_NAME: macos-15-xcode-16
    VERSION: main-${CI_COMMIT_SHORT_SHA}
  script:
    - make upload-to-s3
